<?php
/**
 *    strip_tags()      html .
 *  strip_tags(),    ,    .
 * :
 *   -     "a < b > c"
 *   -   "" html,         < >
 *   -    html
 *   -  , , , PHP, Perl, ASP , MS Word , CDATA
 *   -   ,    html 
 *   -    : "<<fake>script>alert('hi')</</fake>script>"
 *
 * @param   string  $s
 * @param   array   $allowable_tags      ,    
 *                                      : 'b' --    , '<b>' --    
 * @param   bool    $is_format_spaces       ?
 *                                          (plain)        .
 *                                       ,   text/html  text/plain.
 *                                           ,    - .
 * @param   array   $pair_tags      ,      
 *                               .   
 * @param   array   $para_tags      ,      ( $is_format_spaces = true)
 *                               .   
 * @return  string
 *
 * @license  http://creativecommons.org/licenses/by-sa/3.0/
 * @author   Nasibullin Rinat, http://orangetie.ru/
 * @charset  ANSI
 * @version  5.0.14
 */


function strip_tags_smart(
    /*string*/ $s,
    $allowable_tags = '',
    /*boolean*/ $is_format_spaces = false,
    array $pair_tags = array('script', 'style', 'map', 'iframe', 'frameset', 'object', 'applet', 'comment', 'button', 'textarea', 'select'),
    array $para_tags = array('td', 'th', 'li', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'form', 'title', 'pre')
)
{
//echo'<textarea style="width:100%;height:240px;">'.$allowable_tags.'</textarea>';
if (trim($allowable_tags) != ''){
$allowable_tags = str_replace(' ','',$allowable_tags);
$allowable_tags = str_replace('><','>,<',$allowable_tags);
$allowable_tags = str_replace('--','-,-',$allowable_tags);
$allowable_tags = str_replace('>-','>,-',$allowable_tags);
$allowable_tags = str_replace('-<','-,<',$allowable_tags);
$allowable_tags = explode (',',$allowable_tags);
foreach ($allowable_tags as $hgf){
	$hgf =  trim($hgf,'<> /');
	$hgf =  preg_replace('#-(.*)-#is','<\\1>',$hgf);
	$alle_tags[]= $hgf;
	$pair_no  = trim($hgf,'<> /');
	if (in_array ($pair_no,$pair_tags)) unset($pair_tags[array_search($pair_no, $pair_tags)]);
}
}
$allowable_tags =$alle_tags;
//var_export($allowable_tags);
    //return strip_tags($s);
    if (!is_array($s)){
preg_match_all ("#\[code\](.*)\[\/code\]#is",$s,$code_story); 
foreach ($code_story[0] as $key =>$value){$no_code['code_'.$key] = $value;}

preg_match_all ("#<code>(.*)</code>#is",$s,$code_story); 
foreach ($code_story[0] as $key =>$value){$no_codev['codev_'.$key] = $value;}

if (count($no_code))$s=strtr ($s,array_flip($no_code));
if (count($no_codev))$s=strtr ($s,array_flip($no_codev));
}

    static $_callback_type  = false;
    static $_allowable_tags = array();
    static $_para_tags      = array();
    #regular expression for tag attributes
    #correct processes dirty and broken HTML in a singlebyte or multibyte UTF-8 charset!
    static $re_attrs_fast_safe =  '(?![a-zA-Z\d])  #statement, which follows after a tag
                                   #correct attributes
                                   (?>
                                       [^>"\']+
                                     | (?<=[\=\x20\r\n\t]|\xc2\xa0) "[^"]*"
                                     | (?<=[\=\x20\r\n\t]|\xc2\xa0) \'[^\']*\'
                                   )*
                                   #incorrect attributes
                                   [^>]*+';

    if (is_array($s))
    {
        if ($_callback_type === 'strip_tags')
        {
            $tag = strtolower($s[1]);
            if ($_allowable_tags)
            {
                #tag with attributes
                if (array_key_exists($tag, $_allowable_tags)) return $s[0];

                #tag without attributes
                if (array_key_exists('<' . $tag . '>', $_allowable_tags))
                {
                    if (substr($s[0], 0, 2) === '</') return '</' . $tag . '>';
                    if (substr($s[0], -2) === '/>')   return '<' . $tag . ' />';
                    return '<' . $tag . '>';
                }
            }
            if ($tag === 'br') return "\r\n";
            if ($_para_tags && array_key_exists($tag, $_para_tags)) return "\r\n\r\n";
            return '';
        }
        trigger_error('Unknown callback type "' . $_callback_type . '"!', E_USER_ERROR);
    }

    if (($pos = strpos($s, '<')) === false || strpos($s, '>', $pos) === false)  #speed improve
    {
        #tags are not found
        return $s;
    }

    $length = strlen($s);

    #unpaired tags (opening, closing, !DOCTYPE, MS Word namespace)
    $re_tags = '~  <[/!]?+
                   (
                       [a-zA-Z][a-zA-Z\d]*+
                       (?>:[a-zA-Z][a-zA-Z\d]*+)?
                   ) #1
                   ' . $re_attrs_fast_safe . '
                   >
                ~sxSX';

    $patterns = array(
        '/<([\?\%]) .*? \\1>/sxSX',     # PHP, Perl, ASP 
        #'/<\!\[CDATA\[ .*? \]\]>/sxSX', # CDATA
        #'/<\!\[  [\x20\r\n\t]* [a-zA-Z] .*?  \]>/sxSX',  #:DEPRECATED: MS Word   <![if! vml]>...<![endif]>

        '/<\!--.*?-->/sSX', #

        #MS Word   "<![if! vml]>...<![endif]>",
        #    IE  "<!--[if expression]> HTML <![endif]-->"
        #    IE  "<![if expression]> HTML <![endif]>"
        #. http://www.tigir.com/comments.htm
        '/ <\! (?:--)?+
               \[
               (?> [^\]"\']+ | "[^"]*" | \'[^\']*\' )*
               \]
               (?:--)?+
           >
         /sxSX',
    );
    if ($pair_tags)
    {
        #    :
        foreach ($pair_tags as $k => $v) $pair_tags[$k] = preg_quote($v, '/');
        $patterns[] = '/ <((?i:' . implode('|', $pair_tags) . '))' . $re_attrs_fast_safe . '(?<!\/)>
                         .*?
                         <\/(?i:\\1)' . $re_attrs_fast_safe . '>
                       /sxSX';
    }
    #d($patterns);

    $i = 0; #  
    $max = 99;
    while ($i < $max)
    {
        $s2 = preg_replace($patterns, '', $s);
        if (preg_last_error() !== PREG_NO_ERROR)
        {
            $i = 999;
            break;
        }

        if ($i == 0)
        {
            $is_html = ($s2 != $s || preg_match($re_tags, $s2));
            if (preg_last_error() !== PREG_NO_ERROR)
            {
                $i = 999;
                break;
            }
            if ($is_html)
            {
                if ($is_format_spaces)
                {
                    /*
                      PCRE  PHP \s -    ,     [\x09\x0a\x0c\x0d\x20\xa0] ,  , [\t\n\f\r \xa0]
                     \s    /u,  \s   [\x09\x0a\x0c\x0d\x20]
                          ,         
                    */
                    #$s2 = str_replace(array("\r", "\n", "\t"), ' ', $s2);
                    #$s2 = strtr($s2, "\x09\x0a\x0c\x0d", '    ');
                    $s2 = preg_replace('/  [\x09\x0a\x0c\x0d]++
                                         | <((?i:pre|textarea))' . $re_attrs_fast_safe . '(?<!\/)>
                                           .+?
                                           <\/(?i:\\1)' . $re_attrs_fast_safe . '>
                                           \K
                                        /sxSX', ' ', $s2);
                    if (preg_last_error() !== PREG_NO_ERROR)
                    {
                        $i = 999;
                        break;
                    }
                }

                # ,    
                if ($allowable_tags) $_allowable_tags = array_flip($allowable_tags);

                # ,     
                if ($para_tags) $_para_tags = array_flip($para_tags);
            }
        }#if

        #tags processing
        if ($is_html)
        {
            $_callback_type = 'strip_tags';
            $s2 = preg_replace_callback($re_tags, __FUNCTION__, $s2);
            $_callback_type = false;
            if (preg_last_error() !== PREG_NO_ERROR)
            {
                $i = 999;
                break;
            }
        }

        if ($s === $s2) break;
        $s = $s2; $i++;
    }#while
    if ($i >= $max) $s = strip_tags($s); #too many cycles for replace...

    if ($is_format_spaces && strlen($s) !== $length)
    {
        #remove a duplicate spaces
        $s = preg_replace('/\x20\x20++/sSX', ' ', trim($s));
        #remove a spaces before and after new lines
        $s = str_replace(array("\r\n\x20", "\x20\r\n"), "\r\n", $s);
        #replace 3 and more new lines to 2 new lines
        $s = preg_replace('/[\r\n]{3,}+/sSX', "\r\n\r\n", $s);
    }
	$s = str_replace ('<![CDATA[', '', $s);
	$s = str_replace (']]>', '', $s);
if (count($no_code))$s=strtr ($s,$no_code);
if (count($no_codev))$s=strtr ($s,$no_codev);
    return $s;
}

if (!function_exists("preg_last_error")) {
   if (!defined("PREG_NO_ERROR")) { define("PREG_NO_ERROR", 0); }
   if (!defined("PREG_INTERNAL_ERROR")) { define("PREG_INTERNAL_ERROR", 1); }
   if (!defined("PREG_BACKTRACK_LIMIT_ERROR")) { define("PREG_BACKTRACK_LIMIT_ERROR", 2); }
   if (!defined("PREG_RECURSION_LIMIT_ERROR")) { define("PREG_RECURSION_LIMIT_ERROR", 3); }
   if (!defined("PREG_BAD_UTF8_ERROR")) { define("PREG_BAD_UTF8_ERROR", 4); }
   function preg_last_error() {
      return PREG_NO_ERROR;
   }
}

?>